/* The Cantus project.
 * (c)2002, 2003, 2004 by Samuel Abels (spam debain org)
 * This project's homepage is: http://www.debain.org/cantus
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#ifndef HAVE_GUI_PREFTREE_H
#define HAVE_GUI_PREFTREE_H

#include <iostream>
#include <gtkmm.h>

#define _(String) gettext (String)
#define gettext_noop(String) (String)
#define N_(String) gettext_noop (String)


class PreferencesTree : public Gtk::TreeView {
public:
  PreferencesTree();
  ~PreferencesTree();
  
  /* Triggered whenever an item has been selected. */
  SigC::Signal1<void, Gtk::TreeIter> signal_selection_changed;
  
  /* Add a category with an icon. */
  void add(std::string catname, std::string pixmapfile);
  
private:
  void on_selection_changed(void);
  
  // List model columns.
  class ModelColumns : public Gtk::TreeModel::ColumnRecord {
  public:
    //Gtk::TreeModelColumn<Glib::RefPtr<Gdk::Pixbuf> > pixbuf;
    Gtk::TreeModelColumn<Glib::ustring>               caption;
    ModelColumns() {
      //add(pixbuf);
      add(caption);
    }
  };
  Glib::RefPtr<Gtk::ListStore> store;
  Gtk::CellRendererText        renderer_text;
  ModelColumns                 columns;
};

#endif
