#! /usr/bin/env python
#
# setup.py for Gourmet
#
# 

import imp
import sys
import glob
import os.path

#from distutils.core import setup
from tools.gourmet_distutils import setup
from distutils.command.install_data import install_data

name= 'gourmet'
version = '0.5.2'

if sys.version < '2.2':
    sys.exit('Error: Python-2.2 or newer is required. Current version:\n %s'
             % sys.version)


def modules_check():
    '''Check if necessary modules is installed.
    The function is executed by distutils (by the install command).'''
    try:
        import pygtk
        pygtk.require('2.0')
        import gtk
        v1,v2,v3 = gtk.pygtk_version
        if v1 < 2 or v2 < 3 or v3 < 93:
            print 'Error: PyGTK-2.3.93 or newer is required.'
    except:
        sys.exit('Error: PyGTK-2.3.93 or newer is required.')
    mod_list = ['metakit','Image','gtk.glade']
    ok = 1
    for m in mod_list:
        try:
            exec('import %s' % m)
        except ImportError:
            ok = False
            print 'Error: %s Python module is required to install %s' \
                  % (m, name.title())
    if not ok:
        sys.exit(1)

def data_files():
    '''Build list of data files to be installed'''
    images = glob.glob(os.path.join('images','*.png'))
    style = glob.glob(os.path.join('style','*.css'))
    glade = glob.glob(os.path.join('glade','*.glade'))
    images.extend(style)
    images.extend(glade)
    #print "data_files: ",images,style
    files = [('share/pixmaps/', [os.path.join('images','recbox.png')]),
             ('share/applications/',['gourmet.desktop']),
        ('share/gourmet/', images + [os.path.join('data','recipe.dtd')
                                  ])]
    return files

class my_install_data(install_data):
    def finalize_options(self):
        self.set_undefined_options('install',
                                   ('install_lib', 'install_dir'))
        install_data.finalize_options(self)
        
setup(name = name,
      version = version,
      description = 'Recipe Organizer and Shopping List Generator for Gnome',
      author = 'Thomas Mills Hinkle',
      author_email = 'Thomas_Hinkle@alumni.brown.edu',
      url = 'http://grecipe-manager.sourceforge.net',
      license = 'GPL',
      data_files = data_files(),
      modules_check = modules_check,
      packages = ['gourmet'],
      package_dir = {'gourmet' : 'src/lib'},
      scripts = ['src/gourmet'],
      cmdclass={'install_data' : my_install_data}
      )
