#!/usr/bin/python
import gtk # only needed for threading voodoo
import rmetakit, keymanager, convert
from debug import debug

class importer:
    def __init__ (self, rd, threaded=False):
        self.rd=rd
        self.position=0
        self.group=None
        self.threaded=threaded
        if hasattr(self.rd,'km'):
            self.km=self.rd.km
        else:
            self.km=keymanager.KeyManager(kd=self.rd.kd)
        

    def start_rec (self, dict=None, base="import"):
        self.added_ings=[]
        if dict:
            self.rec=dict
        else:
            self.rec = {}
        if not self.rec.has_key('id'):
            self.rec['id']=self.rd.new_id(base)
        #print "DEBUG: New Import's ID=",self.rec['id']

    def commit_rec (self):
        if self.rec.has_key('servings'):
            self.rec['servings']=str(self.convert_servings(self.rec['servings']))
        self.rd.add_rec(self.rec)


    def convert_servings (self, str):
        debug('converting servings for %s'%str,5)
        try:
            return float(str)
        except:
            try:
                return convert.frac_to_float(str)
            except:
                m=re.match("([0-9/. ]+)",str)
                if m:
                    num=m.groups()[0]
                    try:
                        return float(num)
                    except:
                        try:
                            return convert.frac_to_float(num)
                        except:
                            return ""
                else:
                    return ""
            

    def start_ing (self, **kwargs):        
        self.ing=kwargs
        self.ing['id']=self.rec['id']
                 
    def commit_ing (self):
        if not ((self.ing.has_key('refid') and self.ing['refid']) or (self.ing.has_key('key') and self.ing['key'])):
            self.ing['key']=self.km.get_key(self.ing['item'],0.9)
        if not (self.ing.has_key('position') and self.ing['position']):
            self.ing['position']=self.position
            self.position+=1
        if self.group:
            self.ing['group']=self.group
        #print "committing ing: ",self.ing
        self.added_ings.append(self.rd.add_ing(self.ing))

    def add_amt (self, amount):
        """We should NEVER get non-numeric amounts.
        Amounts must contain [/.0-9 ] e.g. 1.2 or 1 1/5
        or 1/3 etc."""
        try:
            self.ing['amount']=convert.frac_to_float(amount)
        except:
            self.ing['amount']=float(amount)

    def add_ref (self, id):
        self.ing['refid']=id
        self.ing['unit']='recipe'

    def add_item (self, item):
        self.ing['item']=item.strip()

    def add_unit (self, unit):
        self.ing['unit']=unit.strip()

    def add_key (self, key):
        self.ing['key']=key.strip()
