#!/usr/bin/env python
import gtk.glade, gtk, gobject, os.path, time, os, sys, re, threading, gtk.gdk, Image, StringIO, pango, string
import rxml_to_metakit, rmetakit, convert, exporter, importer, rmmf_to_metakit, shopgui, GourmetRecipeManager
from recindex import RecIndex
import prefs, WidgetSaver
import dialog_extras as de
import treeview_extras as te
from get_pixbuf_from_file import get_pixbuf_from_jpg
from debug import *
from globals import *

class RecCard:
    def __init__ (self, RecGui, recipe=None):
        debug("__init__ (self, RecGui):",5)
        from timeEntry import makeTimeEntry
        gtk.glade.set_custom_widget_callbacks(locals())
        self.glade = gtk.glade.XML(os.path.join(gladebase,'recCard.glade'))
        self.timeB = self.glade.get_widget('preptimeBox')
        self.timeB.connect('changed',self.setEdited)
        self.rg = RecGui
        self.prefs = self.rg.prefs
        self.ImageBox = ImageBox(self)        
        self.rg.sl.sh.init_orgdic()
        self.selected=gtk.TRUE        
        self.ie = IngredientEditor(self.rg, self)
        self.serveW = self.glade.get_widget('servingsBox')
        self.multCheckB = self.glade.get_widget('rcMultCheck')
        self.multLabel = self.glade.get_widget('multLabel')
        self.applyB = self.glade.get_widget('saveButton')
        self.revertB = self.glade.get_widget('revertButton')
        self.mult = 1
        self.serveW.connect('changed',self.servingsChange)
        self.serves = float(self.serveW.get_text())
        self.widget = self.glade.get_widget('recCard')
        self.stat = self.glade.get_widget('statusbar1')
        self.contid = self.stat.get_context_id('main')
        self.delButton = self.glade.get_widget('ingDelButton')
        self.default_title = "Recipe Card: "
        self.create_ingTree()
        self.selection=gtk.TRUE
        self.selection_changed()
        self.initRecipeWidgets()
        self.setEdited(False)
        self.images = []
        if recipe:
            self.updateRecipe(recipe)
        else:
            r=self.rg.rd.new_rec()
            #if not self.ie.visible:
            #    self.ie.visible=True
            #    self.ie.toggleVisible()
            if self.multCheckB.get_active():
                self.multCheckB.set_active(False)
            self.updateRecipe(r)
        self.pref_id = 'rc%s'%self.current_rec.id
        self.conf = []
        self.conf.append(WidgetSaver.WindowSaver(self.widget, self.prefs.get(self.pref_id,{})))
        for name,widget in self.expanders.items():
            self.conf.append(
                WidgetSaver.WidgetSaver(widget,
                                        self.prefs.get('%s%s'%(self.pref_id,
                                                               name),
                                                       {'expanded':widget.get_expanded()}),
                                        signals=['activate'])
                )
        self.glade.signal_autoconnect({
            'rc2shop' : self.addToShopL,
            'rcDelete' : self.delete,
            'rcHide' : self.hide,
            'saveEdits': self.saveEditsCB,
            'addIng' : self.newIngCB,
            'newRec' : self.newRecipeCB,
            'rcToggleMult' : self.multTogCB,
            'toggleEdit' : self.saveEditsCB,
            'rcSave' : self.saveAs,
            'rcEdited' : self.setEdited,
            'setRecImage' : self.ImageBox.set_from_fileCB,
            'delRecImage' : self.ImageBox.removeCB,
            'instrAddImage' : self.addInstrImageCB,
            'rcRevert' : self.revertCB,
            'ieUp' : self.ingUpCB,
            'ieDown' : self.ingDownCB,
            'ieNewGroup' : self.ingNewGroupCB,
            'recRef':lambda *args: RecSelector(self.rg,self),
            'importIngs': self.importIngredientsCB
            })
        self.show()
        # hackish, but focus was acting funny
        self.rw['title'].grab_focus()

    def multTogCB (self, w, *args):
        debug("multTogCB (self, w, *args):",5)
        if not self.multCheckB.get_active():
            old_mult = self.mult
            self.mult = 1
            self.multLabel.set_text("")
            if old_mult != self.mult:
                self.imodel = self.create_imodel(self.current_rec,mult=self.mult)
                self.ingTree.set_model(self.imodel)
                self.selection_changed()
                self.ingTree.expand_all()
                self.serveW.set_value(float(self.serves_orig))
        
    def modTogCB (self, w, *args):
        debug("modTogCB (self, w, *args):",5)
        if w.get_active():
            self.rw['modifications'].show()
        else:
            self.rw['modifications'].hide()

    def instrTogCB (self, w, *args):
        debug("instrTogCB (self, w, *args):",5)
        if w.get_active():
            self.rw['instructions'].show()
        else:
            self.rw['instructions'].hide()

    def addInstrImage (self, file):
        debug("addInstrImage (self, file):",5)
        w = self.rw['instructions']
        i = gtk.Image()
        i.set_from_file(file)
        pb=i.get_pixbuf()
        i=None
        b=w.get_buffer()
        iter=b.get_iter_at_offset(0)
        anchor = b.create_child_anchor(iter)
        self.images.append((anchor,pb))
        b.insert_pixbuf(iter,pb)

    def addInstrImageCB (self, *args):
        debug("addInstrImageCB (self, *args):",5)
        f = de.select_file("Choose an image to insert in instructions... ")
        self.addInstrImage(f)

    def saveEditsCB (self, click=None, click2=None, click3=None):
        debug("saveEditsCB (self, click=None, click2=None, click3=None):",5)
        self.rg.message("Committing edits! (You still need to save changes to make these changes permanent)")
        newdict = {'id': self.current_rec.id}
        for c in self.reccom:
            newdict[c]=self.rw[c].entry.get_text()
        for e in self.recent:
            if e=='servings':
                newdict[e]=self.serves_orig
            else:
                newdict[e]=self.rw[e].get_text()
        for t in self.rectexts:
            buf = self.rw[t].get_buffer()
            newdict[t]=buf.get_text(buf.get_start_iter(),buf.get_end_iter())
        debug("modify_rec, newdict=%s"%newdict,5)
        self.rg.rd.modify_rec(self.current_rec,newdict)
        ## then, we remove the duplicate item
        self.rg.rd.rview.remove(self.rg.rd.rview.filter(lambda row: self.are_equal(self.current_rec,row)))
        if self.ImageBox.edited:
            self.ImageBox.commit()
            self.ImageBox.edited=False
        self.setEdited(False)
        ## if our title has changed, we need to update menus
        if newdict.has_key('title'):
            self.widget.set_title("%s %s"%(self.default_title,self.current_rec.title))
            self.rg.updateViewMenu()
            
    def delete (self, *args):
        debug("delete (self, *args):",2)
        self.rg.delete_rec(self.current_rec)
        debug("delete finished",2)
    
    def are_equal (self, obj1, obj2):
        debug("are_equal (self, obj1, obj2):",5)
        """A lambda-syntax-necessitated hack"""
        if obj1 == obj2:
            return True
        else:
            return False

    def addToShopL (self, *args):
        debug("addToShopL (self, *args):",5)
        d = shopgui.getOptionalIngDic(self.rg.rd.get_ings(self.current_rec),self.mult)
        self.rg.sl.addRec(self.current_rec,self.mult,d)
        self.rg.sl.show()

    def getServes (self):
        debug("getServes (self):",5)
        txt = self.serveW.get_text()
        if txt != "":
            self.serves = float(self.serveW.get_text())
        return self.serves

    def servingsChange (self, *args):
        debug("servingsChange (self, *args):",5)
        self.getServes()
        if self.multCheckB.get_active():
            if self.serves_orig == 0:
                ## a hack to avoid a divide-by-zero error
                ## in case someone has nonsensically created
                ## a recipe of 0 servings
                self.serves_orig = 1
            self.mult = self.serves / self.serves_orig
            if self.mult==1:
                self.multLabel.set_text("")
            else:
                self.multLabel.set_text("x%s"%convert.float_to_frac(self.mult))
            self.imodel = self.create_imodel(self.current_rec,mult=self.mult)
            self.ingTree.set_model(self.imodel)
            self.ingTree.expand_all()
            self.selection_changed()
        else:
            if self.serves != self.serves_orig:
                self.serves_orig=self.serves
                self.setEdited(True)

    def initRecipeWidgets (self):
        debug("initRecipeWidgets (self):",5)
        self.expanders = {'instructions':self.glade.get_widget('instrExp'),
                           'modifications':self.glade.get_widget('modExp'),
                          'attributes':self.glade.get_widget('detExp'),
                          'ingredients':self.glade.get_widget('ingExp'),
                          'ieExpander':self.glade.get_widget('ieExpander')}
        self.rw = {}
        self.recent = []
        self.reccom = []
        for a,l,w in REC_ATTRS:
            if w=='Entry': self.recent.append(a)
            elif w=='Combo': self.reccom.append(a)
            else: raise "REC_ATTRS widget type %s not recognized"%w
        self.rectexts = ['instructions', 'modifications']
        for a in self.reccom:
            self.rw[a]=self.glade.get_widget("%sBox"%a)
        for a in self.recent:
            self.rw[a]=self.glade.get_widget("%sBox"%a)            
        for t in self.rectexts:
            self.rw[t]=self.glade.get_widget("%sText"%t)
            self.rw[t].get_buffer().connect('changed',self.setEdited)

    def newRecipeCB (self, *args):
        debug("newRecipeCB (self, *args):",5)
        self.rg.newRecCard()

    def getSelectedIter (self):
        debug("getSelectedIter",0)
        if len(self.imodel)==0:
            debug("getSelectedIter: imodel is empty",0)            
            return None
        try:
            debug("getSelectedIter: grabbing paths",0)            
            ts,paths=self.ingTree.get_selection().get_selected_rows()
            lpath=paths[-1]
            debug("getSelectedIter: grabbing iter",0)            
            group=ts.get_iter(lpath)
        except:
            debug("getSelectedIter: there was an exception",0)            
            group=None
        return group

    def newIngCB (self, *args):
        d={'id':self.current_rec.id}
        ing=self.rg.rd.add_ing(d)
        group=self.getSelectedIter()
        debug("group=%s"%group,5)
        iter=self.add_ingredient(self.imodel,ing,self.mult,group) #we return iter
        path=self.imodel.get_path(iter)
        # open up (in case we're in a group)
        self.ingTree.expand_to_path(path)
        self.ingTree.set_cursor(path,self.ingColsByName['Amt'])
        #self.ingTree.get_selection().select_iter(iter)
        self.ingTree.grab_focus()

    def ingUpCB (self, *args):
        def moveup (ts, path, itera):            
            if itera:
                prev=self.path_next(path,-1)
                prev_iter=ts.get_iter(prev)
                te.move_iter(ts,itera,sibling=prev_iter,direction="before")
                self.ingTree.get_selection().unselect_path(path)
                self.ingTree.get_selection().select_path(prev)
        ts,paths = self.ingTree.get_selection().get_selected_rows()
        self.pre_modify_tree()        
        paths.reverse()
        for p in paths:
            itera = ts.get_iter(p)
            moveup(ts,p,itera)
        self.commit_positions()
        self.post_modify_tree()
        
    def ingDownCB (self, *args):
        #ts, itera = self.ingTree.get_selection().get_selected()
        def movedown (ts, path, itera):
            if itera:
                next = ts.iter_next(itera)
                te.move_iter(ts,itera,sibling=next,direction="after")
                if next:
                    next_path=ts.get_path(next)
                else:
                    next_path=path
                self.ingTree.get_selection().unselect_path(path)
                self.ingTree.get_selection().select_path(self.path_next(next_path,1))
        ts,paths = self.ingTree.get_selection().get_selected_rows()
        self.pre_modify_tree()
        paths.reverse()        
        for p in paths:
            itera = ts.get_iter(p)
            movedown(ts,p,itera)
            #selected_foreach(movedown)
        self.commit_positions()
        self.post_modify_tree()
        
    def path_next (self, path, inc=1):
        """Return the path NEXT rows after PATH. Next can be negative, in
        which case we get previous paths."""
        next=list(path[0:-1])
        last=path[-1]
        last += inc
        if last < 0:
            last=0
        next.append(last)
        next=tuple(next)
        return next

    def ingNewGroupCB (self, *args):
        self.add_group('New Group',self.imodel,prev_iter=self.getSelectedIter())

    def resetIngList (self, rec=None):
        debug("resetIngList (self, rec=None):",5)
        if not rec:
            rec=self.current_rec
        self.imodel = self.create_imodel(rec,mult=self.mult)
        self.ingTree.set_model(self.imodel)
        self.selection_changed()
        self.ingTree.expand_all()

    def updateRecipe (self, rec, show=True):
        debug("updateRecipe (self, rec):",5)
        if not self.edited or de.getBoolean(parent=self.widget,
                                         label="Abandon your edits to %s?"%self.current_rec.title):
            self.updateRec(rec)
            # grab focus every time we update a recipe
            #self.rg.notebook.next_page()
            if show:
                self.show()

    def revertCB (self, *args):
        if de.getBoolean(parent=self.widget,
                      label="Are you sure you want to abandon your changes?"):
            self.updateRec(self.current_rec)

    def updateRec (self, rec):
        debug("updateRec (self, rec):",5)
        """If handed an ID, we'll grab the rec"""
        if type(rec) == type(""):
            rec=self.rg.rd.get_rec(rec)
        self.current_rec = rec
        try:
            self.serves_orig = float(self.current_rec.servings)
            self.serveW.set_value(float(self.serves_orig))
        except:
            self.serves_orig = None
            self.multCheckB.set_active(False)
            if hasattr(self.current_rec,'servings'):
                debug("Couldn't make sense of %s as number of servings"%self.current_rec.servings,0)
        self.serves = self.serves_orig
        self.servingsChange()
        self.resetIngList(rec)
        for c in self.reccom:
            debug("Widget for %s"%c,5)
            slist = self.rg.rd.get_unique_values(c)
            if not slist:
                self.rg.rd.get_default_values(c)
            self.rw[c].set_popdown_strings(slist)
            self.rw[c].entry.set_text(getattr(rec,c))            
        for e in self.recent:
            self.rw[e].set_text(getattr(rec,e))
        for t in self.rectexts:
            w=self.rw[t]
            b=w.get_buffer()
            b.set_text(getattr(rec,t))
            if re.match('^\s*$',getattr(rec,t)):
                #self.expanders[t].set_expanded(gtk.FALSE)
                self.expanders[t].set_property('expanded',gtk.FALSE)
                #self.togButtons[t].set_active(gtk.FALSE)
            else:
                #nself.expanders[t].set_expanded(gtk.TRUE)
                self.expanders[t].set_property('expanded',gtk.TRUE)                
                #self.togButtons[t].set_active(gtk.TRUE)
        self.servingsChange()
        self.ImageBox.get_image()
        self.ImageBox.edited=False
        self.setEdited(False)
                
    def create_ingTree (self, rec=None, mult=1):
        debug("create_ingTree (self, rec=None, mult=1):        ",5)
        self.ingTree = self.glade.get_widget('ingTree')
        self.ingTree.get_selection().set_mode(gtk.SELECTION_MULTIPLE)
        self.ingTree.expand_all()
        self.ingColsByName = {}
        for n,head,tog,style in [[1,'Amt',False,None],
                                 [2,'Unit',False,None],
                                 [3,'Item',False,None],
                                 [4,'Optional',True,None],
                                 [5,'Key',False,pango.STYLE_ITALIC],
                                 [6,'Shopping Category',False,pango.STYLE_ITALIC],
                                 ]:
            if tog:
                renderer = gtk.CellRendererToggle()
                renderer.set_property('activatable',gtk.TRUE)
                renderer.connect('toggled',self.ingtree_toggled_cb,4,'Optional')
                col=gtk.TreeViewColumn(head, renderer, active=n)
            else:
                renderer = gtk.CellRendererText()
                renderer.set_property('editable',gtk.TRUE)
                renderer.connect('edited',self.ingtree_edited_cb,n,head)
                if style:
                    renderer.set_property('style',style)
                col=gtk.TreeViewColumn(head, renderer, text=n)
            self.ingColsByName[head]=col
            col.set_reorderable(gtk.TRUE)
            col.set_resizable(gtk.TRUE)
            self.ingTree.append_column(col)
        self.setupShopPopupMenu()
        self.ingTree.connect("row-activated",self.ingTreeClickCB)
        self.ingTree.connect("button-press-event",self.ingtree_click_cb)
        self.ingTree.get_selection().connect("changed",self.selection_changedCB)
        self.ingTree.show()
        ## add drag and drop support
        #self.ingTree.drag_dest_set(gtk.DEST_DEFAULT_ALL,
        #                           [("text/plain",0,0)],
        #                           gtk.gdk.ACTION_COPY)
        targets=[('GOURMET_INTERNAL', gtk.TARGET_SAME_WIDGET, 0),
                 ('text/plain',0,1),
                 ('STRING',0,2),
                 ('STRING',0,3),
                 ('COMPOUND_TEXT',0,4),
                 ('text/unicode',0,5),]
        self.ingTree.enable_model_drag_source(gtk.gdk.BUTTON1_MASK,
                                              targets,
                                              gtk.gdk.ACTION_DEFAULT |
                                              gtk.gdk.ACTION_COPY |
                                              gtk.gdk.ACTION_MOVE)
        self.ingTree.enable_model_drag_dest(targets,
                                            gtk.gdk.ACTION_DEFAULT | gtk.gdk.ACTION_COPY | gtk.gdk.ACTION_MOVE)
        self.ingTree.connect("drag_data_received",self.dragIngsRecCB)
        self.ingTree.connect("drag_data_get",self.dragIngsGetCB)
        if len(self.rg.rd.rview) > 1:
            if not rec:
                rec = self.rg.rd.rview[1]
            self.imodel = self.create_imodel(rec, mult=1)
            self.ingTree.set_model(self.imodel)
            self.selection_changed()
            self.ingTree.expand_all()

    def ingtree_click_cb (self, tv, event):
        debug("ingtree_click_cb",5)
        x = int(event.x)
        y = int(event.y)
        time = event.time
        try:
            path, col, cellx, celly = tv.get_path_at_pos(x,y)
        except: return
        debug("ingtree_click_cb: path=%s, col=%s, cellx=%s, celly=%s"%(path,
                                                     col,
                                                     cellx,
                                                     celly),
              5)
        if col.get_title()=='Shopping Category':
            tv.grab_focus()
            tv.set_cursor(path,col,0)
            self.shoppop_iter=tv.get_model().get_iter(path)
            self.shoppop.popup(None,None,None,0,0)
            return True

    def setupShopPopupMenu (self):
        self.shoppop = gtk.Menu()
        new = gtk.MenuItem('New Category')
        self.shoppop.append(new)
        new.connect('activate',self.shop_popup_callback,False)
        new.show()
        sep = gtk.MenuItem()
        self.shoppop.append(sep)
        sep.show()
        for i in self.rg.sl.sh.get_orgcats():
            itm = gtk.MenuItem(i)
            self.shoppop.append(itm)
            itm.connect('activate',self.shop_popup_callback,i)
            itm.show()

    def shop_popup_callback (self, menuitem, i):
        """i is our new category. If i==False, we prompt for
        a category."""
        regenerate_menu=False
        #colnum for key=5
        mod=self.ingTree.get_model()
        key=mod.get_value(self.shoppop_iter,5)
        debug('shop_pop_callback with key %s'%key,5)
        if not i:
            i=de.getEntry(label="Category to add %s to"%key,
                       parent=self.widget)
            if not i:
                return
            regenerate_menu=True
        self.rg.sl.orgdic[key]=i
        mod.set_value(self.shoppop_iter,6,i)
        if regenerate_menu:
            self.setupShopPopupMenu()

    def selection_changedCB (self, *args):
        v=self.ingTree.get_selection().get_selected_rows()[1]
        if v: selected=gtk.TRUE
        else: selected=gtk.FALSE
        self.selection_changed(v)
        return gtk.TRUE

    def selection_changed (self, selected=gtk.FALSE):
        if selected != self.selected:
            if selected: self.selected=gtk.TRUE
            else: self.selected=gtk.FALSE
            if self.delButton:
                self.delButton.set_sensitive(self.selected)
            else: debug("No delButton!",2)

    def ingtree_toggled_cb (self, cellrenderer, path, colnum, head):
        debug("ingtree_toggled_cb (self, cellrenderer, path, colnum, head):",5)
        store=self.ingTree.get_model()
        iter=store.get_iter(path)
        val = store.get_value(iter,colnum)
        newval = not val
        store.set_value(iter,colnum,newval)
        ing=store.get_value(iter,0)
        if head=='Optional':
            if newval:
                self.rg.rd.modify_ing(ing, {'optional':'yes'})
            else:
                self.rg.rd.modify_ing(ing, {'optional':'no'})
        
            
    def ingtree_edited_cb (self, renderer, path_string, text, colnum, head):
        debug("ingtree_edited_cb (self, renderer, path_string, text, colnum, head):",5)
        indices = path_string.split(':')
        path = tuple( map(int, indices))
        store = self.ingTree.get_model()
        iter = store.get_iter(path)
        store.set_value(iter, colnum, text)
        ing=self.selectedIng()
        if head=='Shopping Category':
            self.rg.sl.orgdic[ing.key]=text
        else:
            head_to_att = {'Amt':'amount',
                           'Unit':'unit',
                           'Item':'item',
                           'Key':'key'}
            attr=head_to_att[head]
            if attr=='amount':
                text=convert.frac_to_float(text)
                if not text:
                    show_amount_error(text)
                    raise "Amount is not a number!"
            d={attr:text}
            if attr=='item':
                d['key']=self.rg.rd.km.get_key(text)
                store.set_value(iter,5,d['key'])
            self.rg.rd.modify_ing(ing,d)
            if d.has_key('key'):
                ## if the key has been changed and the shopping category is not set...
                ## COLUMN NUMBER FOR Shopping Category==6
                shopval=store.get_value(iter, 6)
                debug('Shopping Category value was %s'%shopval,4)
                if shopval:
                    self.rg.sl.orgdic[d['key']]=shopval
                else:
                    if self.rg.sl.orgdic.has_key(text):
                        debug('Setting new shopping category!',2)
                        store.set_value(iter, 6, self.rg.sl.orgdic[text])
                    
    def dragIngsRecCB (self, widget, context, x, y, selection, targetType,
                         time):
        debug("dragIngsRecCB (self=%s, widget=%s, context=%s, x=%s, y=%s, selection=%s, targetType=%s, time=%s)"%(self, widget, context, x, y, selection, targetType, time),3)
        drop_info=self.ingTree.get_dest_row_at_pos(x,y)
        mod=self.ingTree.get_model()
        if drop_info:
            path, position = drop_info
            diter = mod.get_iter(path)
            dest_ing=mod.get_value(diter,0)
            if type(dest_ing)==type(""): group=True
            else: group=False
            debug('drop_info good, GROUP=%s'%group,5)
            #new_iter=mod.append(None)
            #path=mod.get_path(new_iter)
        else:
            diter = None
            group = False
            position = None
        #self.pre_modify_tree()            
        if str(selection.target) == 'GOURMET_INTERNAL':
               # if this is ours, we move it
               self.selected_iter.reverse() # all things must go backwards in treeView land...
               if (group and
                   (position==gtk.TREE_VIEW_DROP_INTO_OR_BEFORE
                    or
                    position==gtk.TREE_VIEW_DROP_INTO_OR_AFTER)
                   ):
                   self.pre_modify_tree()
                   for i in self.selected_iter:
                       te.move_iter(mod,i,sibling=diter,direction="before",parent=diter)
                   self.post_modify_tree()
               elif (position==gtk.TREE_VIEW_DROP_INTO_OR_BEFORE
                     or
                     position==gtk.TREE_VIEW_DROP_BEFORE):
                   self.pre_modify_tree()
                   for i in self.selected_iter:
                       te.move_iter(mod,i,sibling=diter,direction="before")
                   self.post_modify_tree()                       
               else:
                   self.pre_modify_tree()
                   for i in self.selected_iter:
                       te.move_iter(mod,i,sibling=diter,direction="after")
                   self.post_modify_tree()                       
               #self.ingTree.get_selection().select_iter(new_iter)
        else:
            # if this is external, we copy
            debug('external drag!',2)
            for l in selection.data.split("\n"):
                self.add_ingredient_from_line(l)
        self.commit_positions()
        debug("restoring selections.")
        #self.post_modify_tree()
        debug("done restoring selections.")        

    def add_ingredient_from_line (self, line):
        """Add an ingredient to our list from a line of plain text"""
        d=self.rg.rd.ingredient_parser(line, conv=self.rg.conv)
        self.pre_modify_tree()
        if d:
            d['id']=self.current_rec.id
            i=self.rg.rd.add_ing(d)
            iter=self.add_ingredient(self.imodel,i,self.mult)
            self.ss.add_selection(iter)
        self.post_modify_tree()

    def pre_modify_tree (self):
        """This shouldn't really be necessary, but I'm getting
        a lot of bizarre behavior and segfaults from modifying
        the tree while connected.
        So, this should be called before adding, deleting or
        moving rows in our model"""
        debug('pre_modify_tree called',5)
        self.ss = te.selectionSaver(self.ingTree)
        debug('disconnecting tree')
        self.ingTree.set_model(None)
        debug('pre_modify_tree done')

    def post_modify_tree (self):
        """And this must be called after adding, deleting or
        moving rows in our model."""
        debug('post_modify_tree called')
        self.ingTree.set_model(self.imodel)
        debug('expanding all')        
        self.ingTree.expand_all()
        debug('restoring selections')                
        self.ss.restore_selections()
        debug('post_modify_tree done')
        
    def commit_positions (self):
        debug("Committing positions",4)
        iter=self.imodel.get_iter_first()
        self.edited=True
        n=0
        def commit_iter(iter,pos,group=None):
            debug("iter=%s,pos=%s,group=%s"%(iter,pos,group),5)
            ing=self.imodel.get_value(iter,0)
            if type(ing)==type(""):
                group=self.imodel.get_value(iter,1)
                i=self.imodel.iter_children(iter)
                while i:
                    pos=commit_iter(i,pos,group)
                    i=self.imodel.iter_next(i)
            else:
                ing.position=pos
                if group: ing.group=group
                pos+=1
            return pos
        while iter:
            n=commit_iter(iter,n)
            iter=self.imodel.iter_next(iter)
            debug("Next iter = %s"%iter)
        debug("Done committing positions",4)

    
        
    def dragIngsGetCB (self, tv, context, selection, info, timestamp):
        def grab_selection (model, path, iter, args):
            strings, iters = args            
            str = ""
            amt = model.get_value(iter,1)
            if amt:
                str="%s "%amt
            unit = model.get_value(iter,2)
            if unit:
                str="%s%s "%(str,unit)
            item = model.get_value(iter,3)
            if item:
                str="%s%s"%(str,item)
            debug("Dragged string: %s, iter: %s"%(str,iter),3)
            iters.append(iter)
            strings.append(str)
        strings=[]
        iters=[]
        tv.get_selection().selected_foreach(grab_selection,(strings,iters))
        str=string.join(strings,"\n")
        selection.set('text/plain',0,str)
        selection.set('STRING',0,str)
        selection.set('GOURMET_INTERNAL',8,'blarg')
        self.selected_iter=iters
        

    def selectedIng (self):
        debug("selectedIng (self):",5)
        path, col = self.ingTree.get_cursor()
        if path:
            itera = self.ingTree.get_model().get_iter(path)
        else:
            tv,rows = self.ingTree.get_selection().get_selected_rows()
            if len(rows) > 0:
                itera = rows[0]
            else:
                itera=None
        if itera: return self.ingTree.get_model().get_value(itera,0)
        else: return None
    
    def ingTreeClickCB (self, tv, path, col, p=None):
        debug("ingTreeClickCB (self, tv, path, col, p=None):",5)
        i=self.selectedIng()
        if hasattr(i,'refid') and i.refid:
            rec=self.rg.rd.get_rec(i.refid)
            if rec:
                self.rg.openRecCard(rec)
            else:
                de.show_message(parent=self.widget, label="The recipe %s (ID %s) is not in our database."%(i.item,
                                                                                                           i.refid))
        else: self.ie.show(self.selectedIng())

    def create_imodel (self, rec, mult=1):
        debug("create_imodel (self, rec, mult=1):",5)
        ings=self.rg.rd.get_ings(rec)
        debug("%s ings"%len(ings),3)
        ing_alist=self.rg.rd.order_ings(ings)
        model = gtk.TreeStore(gobject.TYPE_PYOBJECT,
                              gobject.TYPE_STRING,
                              gobject.TYPE_STRING,
                              gobject.TYPE_STRING,
                              gobject.TYPE_BOOLEAN,
                              gobject.TYPE_STRING,
                              gobject.TYPE_STRING)
        self.rg.rd.init_keydic()
        for g,ings in ing_alist:
            if g:
                g=self.add_group(g,model)
            for i in ings:
                debug('adding ingredient %s'%i.item,4)
                self.add_ingredient(model, i, mult, g)
        return model

    def add_group (self, name, model, prev_iter=None):
        debug('add_group',5)
        if not prev_iter:
            groupiter = model.append(None)
        else:
            groupiter = model.insert_after(None,prev_iter,None)
        model.set_value(groupiter, 0, "GROUP %s"%name)
        model.set_value(groupiter, 1, name)
        debug('add_group returning %s'%groupiter,5)
        return groupiter

    def add_ingredient (self, model, ing, mult, group_iter=None):
        """group_iter is an iter to put our ingredient inside of.
        If group_iter is not a group but an ingredient, we'll insert our
        ingredient after it"""
        debug("add_ingredient (self=%s, model=%s, ing=%s, mult=%s, group_iter=%s):"%(self, model, ing, mult, group_iter),5)
        i = ing
        if group_iter:
            if type(model.get_value(group_iter, 0))==type(""):
                debug("Adding to group",4)
                iter = model.append(group_iter)
            else:
                iter = model.insert_after(None, group_iter, None)
                debug("Adding after iter",5)            
        else:
            iter = model.insert_before(None, None, None)
        model.set_value(iter, 0, i)
        model.set_value(iter, 1, convert.float_to_frac(float(i.amount) * mult))
        model.set_value(iter, 2, i.unit)
        model.set_value(iter, 3, i.item)
        if i.optional=='yes':
            opt=gtk.TRUE
        else:
            opt=gtk.FALSE
        model.set_value(iter, 4, opt)
        model.set_value(iter, 5, i.key)
        if self.rg.sl.orgdic.has_key(i.key):
            debug("Key %s has category %s"%(i.key,self.rg.sl.orgdic[i.key]),5)
            model.set_value(iter, 6, self.rg.sl.orgdic[i.key])
        else:
            model.set_value(iter, 6, None)
        return iter

    def importIngredientsCB (self, *args):
        debug('importIngredientsCB',0) #FIXME
        f=de.select_file("Choose a file containing your ingredient list.")
        self.importIngredients(f)
        
    def importIngredients (self, file):
        ifi=open(file,'r')
        for line in ifi:
            self.add_ingredient_from_line(line)

    def saveAs (self, *args):
        debug("saveAs (self, *args):",5)
        opt = de.getOption(label="Export recipe as...",options=[["Mealmaster","mmf"],["HTML","htm"],["Plain Text","txt"]])
        fn=de.select_file(winTitle="Save recipe as...",filename="~/%s.%s"%(self.current_rec.title,opt))
        out=open(fn,'w')
        if opt=='htm':
            exporter.html_exporter(self.rg.rd,self.current_rec,out)
        elif opt=='txt':
            exporter.exporter(self.rg.rd,self.current_rec,out)
        elif opt=='mmf':
            exporter.mealmaster_exporter(self.rg.rd,self.current_rec,out)
        out.close()

    def setEdited (self, boolean=True):
        debug("setEdited (self, boolean=True):",5)
        self.edited=boolean
        if boolean:
            self.applyB.set_sensitive(gtk.TRUE)
            self.revertB.set_sensitive(gtk.TRUE)
            self.message("You have unsaved changes.")
        else:
            self.applyB.set_sensitive(gtk.FALSE)
            self.revertB.set_sensitive(gtk.FALSE)
            self.message("There are no unsaved changes.")

    def hide (self, *args):
        debug("hide (self, *args):",5)
        if self.edited and de.getBoolean(label="Save edits to %s before closing?"%self.current_rec.title):
            self.saveEditsCB()
        else: self.edited=False #to avoid multiple dialogs if this gets called twice somehow
        # save our position
        for c in self.conf:
            c.save_properties()
        self.widget.hide()
        # delete it from main apps list of open windows
        self.rg.del_rc(self.current_rec.id)
        #return True
        # now we destroy old recipe cards
        
    def show (self, *args):
        debug("show (self, *args):",5)
        self.widget.show()
        try:
            self.widget.set_title("%s %s"%(self.default_title,self.current_rec.title))
            self.widget.present()
        except:
            self.widget.grab_focus()

    def message (self, msg):
        debug('message (self, msg): %s'%msg,5)
        self.stat.push(self.contid,msg)

class ImageBox:
    def __init__ (self, RecCard):
        debug("__init__ (self, RecCard):",5)
        self.rg = RecCard.rg
        self.rc = RecCard
        self.glade = self.rc.glade
        self.imageW = self.glade.get_widget('recImage')
        self.addW = self.glade.get_widget('addImage')
        self.delW = self.glade.get_widget('delImageButton')
        self.image = None
        changed=False

    def get_image (self, rec=None):
        debug("get_image (self, rec=None):",5)
        if not rec:
            rec=self.rc.current_rec
        if rec.image:
            self.set_from_string(rec.image)
        else:
            self.image=None
            self.hide()

    def hide (self):
        debug("hide (self):",5)
        self.imageW.hide()
        self.delW.hide()
        self.addW.show()
        return True
        
    def commit (self):
        debug("commit (self):",5)
        """Put current image in database"""
        if self.image:
            file = StringIO.StringIO()
            self.image.save(file,"JPEG")
            self.rc.current_rec.image=file.getvalue()
            file = StringIO.StringIO()
            self.thumb.save(file,"JPEG")
            self.rc.current_rec.thumb=file.getvalue()
        else:
            self.rc.current_rec.image=""
            self.rc.current_rec.thumb=""

    def resize_image (self, image, width=None, height=None):
        debug("resize_image (self, image, width=None, height=None):",5)
        """Resize an image to have a maximum width=width or height=height.
        We only shrink, we don't grow."""
        iwidth,iheight=image.size
        resized=False
        if width and iwidth > width:
            newheight=int((float(width)/float(iwidth)) * iheight)
            if not height or newheight < height:
                retimage=image.resize((width, newheight))
                resised=True
        if not resized and height and iheight > height:
            newwidth = int((float(height)/float(iheight)) * iwidth)
            retimage = image.resize((newwidth,height))
            resized=True
        if resized:
            return retimage
        else:
            return image

    def draw_image (self):
        debug("draw_image (self):",5)
        """Put image onto widget"""
        if self.image:
            self.win = self.imageW.get_parent_window()
            if self.win:
                wwidth,wheight=self.win.get_size()
                wwidth=int(float(wwidth)/3)
                wheight=int(float(wheight)/3)
            else:
                wwidth,wheight=100,100
            #self.image=self.resize_image(self.image,wwidth,wheight)
            self.thumb=self.resize_image(self.image,40,40)
            self.image.save('/tmp/recimage.png')
            self.imageW.set_from_file('/tmp/recimage.png')            
            self.show_image()
        else:
            self.hide()

    def show_image (self):
        debug("show_image (self):",5)
        """Show widget and switch around buttons sensibly"""
        self.addW.hide()
        self.imageW.show()
        self.delW.show()

    def set_from_string (self, string):
        debug("set_from_string (self, string):",5)
        #o=open('/tmp/rectemp.jpg','w')
        #o.write(string)
        #o.close
        #self.set_from_file('/tmp/rectemp.jpg')
        pb=get_pixbuf_from_jpg(string)
        self.imageW.set_from_pixbuf(pb)
        self.show_image()

    def set_from_file (self, file):
        debug("set_from_file (self, file):",5)
        self.image = Image.open(file)
        self.draw_image()        
        
    def set_from_fileCB (self, *args):
        debug("set_from_fileCB (self, *args):",5)
        f=de.select_file("Select Image")
        if f:
            self.set_from_file(f)
            self.rc.setEdited(True)
            self.edited=True

    def removeCB (self, *args):
        debug("removeCB (self, *args):",5)
        if de.getBoolean(label="Are you sure you want to remove this image?",
                      parent=self.rc.widget):
            self.rc.current_rec.image=''
            self.image=None
            self.draw_image()
            
class IngredientEditor:
    def __init__ (self, RecGui, rc):
        debug("__init__ (self, RecGui):",5)
        self.ing = None
        self.user_set_key=False
        self.user_set_shopper=False
        self.we_changed_key=False
        self.we_changed_shop=False        
        self.rc=rc
        self.glade=rc.glade
        self.rg = RecGui
        self.orgdic = self.rg.sl.sh.orgdic
        self.keydic = self.rg.sl.sh.dic
        self.rg.rd.init_keydic()
        self.rg.rd.km.set_keylist()
        self.keys=self.rg.rd.km.keys
        # we need the shopper class to maek a keydict of all ings
        #self.visible = False
        #self.glade.signal_connect('ieToggle', self.toggleVisible_cb)
        self.glade.signal_connect('ieKeySet', self.keySet)
        self.glade.signal_connect('ieShopSet', self.shopSet)
        self.glade.signal_connect('ieAdd', self.add)
        self.glade.signal_connect('ieNew', self.new)
        self.glade.signal_connect('ieDel', self.delete_cb)
        #self.glade.signal_connect('ieApply', self.apply)
        self.glade.signal_connect('ieKeyUpdate', self.setKeyList)
        self.ieBox = self.glade.get_widget('ieBox')
        self.ieExpander = self.glade.get_widget('ieExpander')
        #self.ieBox.hide()
        self.amountBox = self.glade.get_widget('ieAmount')
        self.unitBox = self.glade.get_widget('ieUnit')
        ## this next bit of a hack grabs the car of each item
        ## in the conv.units alist (to use lisp terminology).
        self.unitBox.set_popdown_strings(map(lambda a: a[0], self.rg.conv.units))
        self.keyBox = self.glade.get_widget('ieKey')
        self.ingBox = self.glade.get_widget('ieIng')
        self.shopBox = self.glade.get_widget('ieShopCat')
        self.optCheck = self.glade.get_widget('ieOptional')
        self.shopcats = self.rg.sl.sh.get_orgcats()
        self.togWidget = self.glade.get_widget('ieTogButton')
        self.shopBox.set_popdown_strings(self.shopcats)
        self.new()
#        self.glade.signal_autoconnect({
#            'ieToggle' : self.toggleVisible
#            })

    def keySet (self, *args):
        debug("keySet (self, *args):",5)
        if not self.we_changed_key==True:
            if not re.match("^\s*$",self.keyBox.entry.get_text()):
                self.user_set_key=True
                self.setShopper()
            else:
                self.user_set_key=False #if user blanks key, we do our automagic again

    def shopSet (self, *args):
        pass

    def addKey (self,key,item):
        debug("addKey (self,key,item):",5)
        self.keys.append(key)
        if self.keydic.has_key(item):
            self.keydic[item].append(key)
        else:
            self.keydic[item]=[key]
    
    def getKey (self):
        debug("getKey (self):        ",5)
        kk=self.keyBox.entry.get_text()
        if kk:
            return kk
        else:
            #return self.myKeys[0]
            ""
        
    def getKeyList (self):
        debug("getKeyList (self):",5)
        ing = self.ingBox.get_text()
        return self.rg.rd.key_search(ing)

    def setKeyList (self, *args):
        debug("setKeyList (self, *args):        ",5)
        myKeys = self.getKeyList()
        if myKeys:
            if not self.user_set_key:
                self.we_changed_key=True            
                self.keyBox.entry.set_text(myKeys[0])
                self.setShopper()
            else:
                orig = [self.getKey()]
                orig.extend(myKeys)
                myKeys=orig
            myKeys.extend(self.keys)
            self.keyBox.set_popdown_strings(myKeys)
            self.we_changed_key=False
        else:
            self.we_changed_key=True
            self.keyBox.set_popdown_strings(self.keys)
            self.we_changed_key=False
        self.myKeys = myKeys
        

    def setShopper (self):
        debug("setShopper (self):",5)
        if not self.user_set_shopper:
            sh = self.getShopper()
            if sh:
                self.we_changed_shop=True
                self.shopBox.entry.set_text(sh)
                self.we_changed_shop=False
                
    def getShopper (self):
        debug("getShopper (self):",5)
        key = self.getKey()
        if self.orgdic.has_key(key):
            return self.orgdic[key]
        else:
            return None
                         
    def show (self, ing):
        debug("show (self, ing):",5)
        self.ing = ing
        if hasattr(ing,'item'):
            self.ingBox.set_text(ing.item)
        if hasattr(ing,'key'):
            self.keyBox.entry.set_text(ing.key)
            self.keyBox.entry.user_set_key=True
        else:
            self.user_set_key=False            
        if hasattr(ing,'amount'):
            self.amountBox.set_text(convert.float_to_frac(float(ing.amount) * self.rc.mult))
        if hasattr(ing,'unit'):
            self.unitBox.entry.set_text(ing.unit)
        if hasattr(ing,'optional') and ing.optional=='yes':
            self.optCheck.set_active(gtk.TRUE)
        else:
            self.optCheck.set_active(gtk.FALSE)
        self.user_set_shopper=False
        self.getShopper()

    def new (self, *args):
        debug("new (self, *args):",5)
        self.ing = None
        self.unitBox.entry.set_text("")
        self.shopBox.entry.set_text("")
        self.amountBox.set_text("")
        self.ingBox.set_text("")
        self.we_changed_key=True
        self.keyBox.entry.set_text("")
        self.we_changed_key=False
        self.user_set_key=False
        self.user_set_shopper=False
        self.optCheck.set_active(gtk.FALSE)
        self.amountBox.grab_focus()

    def add (self, *args):
        debug("add (self, *args):",5)
        d = {}
        d['id']=self.rc.current_rec.id
        d['key']=self.getKey()
        d['item']=self.ingBox.get_text()
        d['unit']=self.unitBox.entry.get_text()
        amt=self.amountBox.get_text()
        if amt:
            try:
                d['amount']= convert.frac_to_float(amt)/self.rc.mult
            except:
                show_amount_error(amt)
                raise
        if not d['item'] :
            # if there's not an item, we first check if our user
            # made a typing error and meant the item as a "key"
            if d['unit'] and not d['unit'] in self.rg.conv.units:
                itm = d['unit']
                d['item']=d['unit']
                d['unit']=""
                self.rc.message('You forgot an item. Assuming you meant "%s" as an item and not a unit.'%itm)
            else:
                self.rc.message('An ingredient must have an item!')
                return
        if self.optCheck.get_active(): d['optional']='yes'
        else:
            d['optional']='no'
        if d['key']:
            self.addKey(d['key'],d['item'])
        else:
            d['key']=self.rg.rd.key_search(d['item'])[0]
        sh = self.shopBox.entry.get_text()
        if sh:
            self.rg.sl.sh.add_org_itm(d['key'],sh)
        if self.ing:
            i=self.rg.rd.modify_ing(self.ing,d)
            self.rc.resetIngList()
        else:
            i=self.rg.rd.add_ing(d)
            iter=self.rc.add_ingredient(self.rc.imodel,i,self.rc.mult,
                                   group_iter=self.rc.getSelectedIter())
            path=self.rc.imodel.get_path(iter)
            self.rc.ingTree.expand_to_path(path)
            self.rc.ingTree.get_selection().select_iter(iter)
            
        self.new()
        #self.rc.resetIngList()
        #self.new()

    def delete_cb (self, *args):
        debug("delete_cb (self, *args):",5)
        mod,rows = self.rc.ingTree.get_selection().get_selected_rows()
        rows.reverse()
        for p in rows:
            i=mod.get_iter(p)
            ing = mod.get_value(i,0)
            if type(ing) == type(""):
                ## then we're a group
                self.remove_group(i)
            if de.getBoolean(label="Are you sure you want to delete %s?"%ing.item):
                self.rc.pre_modify_tree()
                mod.remove(i)
                self.rc.post_modify_tree()                
                debug('deleting ingredient')
                self.rg.rd.delete_ing(ing)
                
        self.new()

    def remove_group (self, iter):
        nchildren = self.rc.imodel.iter_n_children(iter)
        if type(nchildren) != type(1):
            # if there are no children
            # we just remove the group
            # heading without asking
            # for confirmation
            self.rc.imodel.remove(iter)
            return
        # otherwise, we'll need to be more thorough...
        group = self.rc.imodel.get_value(iter,1)
        if de.getBoolean(label="Are you sure you want to delete %s"%group):
            # collect our childrenp
            children = []
            ings = []
            for n in range(nchildren):
                child=self.rc.imodel.iter_nth_child(iter,n)
                children.append(child)
                i=self.rc.imodel.get_value(child,0)
                ings.append([i.amount,i.unit,i.item])
            if children:
                children.reverse()
                question="Shall I delete the items contained in %s or just move them out of the group?"%group
                tree = te.QuickTree(ings, ["Amount","Unit","Item"])
                debug("de.getBoolean called with:")
                debug("label=%s"%question)
                debug("expander=['See ingredients',%s]"%tree)
                delete=de.getBoolean(label=question,
                                     custom_yes="Delete them.",
                                     custom_no="Move them.",
                                     expander=["See ingredients",tree])
                    # then we're deleting them, this is easy!
                children.reverse()
                self.rc.pre_modify_tree()
                for c in children:
                    ing = self.rc.imodel.get_value(c,0)
                    if delete:
                        self.rc.imodel.remove(c)
                        self.rg.rd.delete_ing(ing)
                    else:
                        ing.group = None
                        te.move_iter(self.rc.imodel, c,
                                     sibling=iter, direction="after")
            else: self.rc.pre_modify_tree()
            self.rc.imodel.remove(iter)
            self.rc.post_modify_tree()
                                 
                
                
            
            
            
class RecSelector (RecIndex):
    """Select a recipe and add it to RecCard's ingredient list"""
    def __init__(self, RecGui, RecCard):
        self.glade=gtk.glade.XML(os.path.join(gladebase,'recSelector.glade'))
        self.glade.signal_connect('cancel',self.cancel)
        self.glade.signal_connect('ok',self.ok)        
        self.rg=RecGui
        self.rc=RecCard
        self.dialog = self.glade.get_widget('recDialog')
        RecIndex.__init__(self, self.rg.rmodel, self.glade, self.rg.rd,
                          self.rg, visible=2)
        # don't allow multiple selections since we're only choosing
        # one recipe to add.

    def quit (self):
        self.dialog.destroy()

    def cancel (self,*args):
        debug('cancel',0)
        self.quit()

    def ok (self,*args):
        debug('ok',0)
        pre_iter=self.rc.getSelectedIter()
        try:
            self.rc.pre_modify_tree()
            for rec in self.recTreeSelectedRecs():
                ingdic={'amount':1,
                        'unit':'recipe',
                        'item':rec.title,
                        'refid':rec.id,
                        'id':self.rc.current_rec.id,}
                debug('adding ing: %s'%ingdic,5)
                i=self.rg.rd.add_ing(ingdic)
                iter=self.rc.add_ingredient(self.rc.imodel,i,
                                            mult=self.rc.mult,
                                            group_iter=pre_iter)
                path=self.rc.imodel.get_path(iter)
                self.rc.ss.add_selection(iter)
            self.rc.post_modify_tree()
            self.rc.commit_positions()
            self.quit()
        except:
            de.show_message(label="You haven't selected any recipes!")
            raise

def show_amount_error (txt):
    """Show an error that explains how numeric amounts work."""
    de.show_message(label="""I'm sorry, I can't understand
the amount "%s"."""%txt,
                                expander=["Details",
                                          """
Amounts must be numbers (fractions or decimals) or blank.
The "unit" must be in the "unit" field by itself.
For example, if you want to enter one and a half cups,
the amount field could contain "1.5" or "1 1/2". "cups"
should go in the separate "unit" field.
"""])
